
sclock200	=	$4BA

*---------------------------------------------------------------*
interrogate_screen:
*---------------------------------------------------------------*
	jsr		Appl_init
	jsr		Graf_handle
	jsr		V_OpenVWork
	lea		int_out,a0
	move.w		(a0)+,d1
	move.w		(a0)+,d2
	addq.w		#1,d1
	addq.w		#1,d2
	move.w		d1,vwork_w
	move.w		d2,vwork_h
	jsr		V_CloseVWork
	jsr		Appl_exit
	rts

*---------------------------------------------------------------*
init_fonts:
*---------------------------------------------------------------*
	dc.w		$A000
	move.l		4(a1),a0
	move.l		data_table(a0),sysfont8x8
	move.l		8(a1),a0
	move.l		data_table(a0),sysfont8x16
	rts

*---------------------------------------------------------------*
Appl_init:
*---------------------------------------------------------------*
	pushall
	lea		control,a0
	move.w		#10,(a0)
	move.w		#0,2(a0)
	move.w		#1,4(a0)
	move.w		#0,6(a0)
	move.w		#0,8(a0)
	bsr		AES
	popall
	rts

*---------------------------------------------------------------*
Appl_exit:
*---------------------------------------------------------------*
	pushall
	lea		control,a0
	move.w		#19,(a0)
	move.w		#0,2(a0)
	move.w		#1,4(a0)
	move.w		#0,6(a0)
	move.w		#0,8(a0)
	bsr		AES
.lp	tst.w		int_out
	beq.s		.lp
	popall
	rts
	
*---------------------------------------------------------------*
Graf_handle:
*---------------------------------------------------------------*
	lea		control,a0
	move.w		#77,(a0)
	move.w		#0,2(a0)
	move.w		#5,4(a0)
	move.w		#0,6(a0)
	bsr		AES
	move.w		int_out,handle
	rts

*---------------------------------------------------------------*
V_OpenVWork:
*---------------------------------------------------------------*
	lea		control,a0
	move.w		#100,(a0)
	move.w		#0,2(a0)
	move.w		#6,4(a0)
	move.w		#11,6(a0)
	move.w		#45,8(a0)
	move.w		handle,12(a0)
	lea		int_in,a0
	moveq		#1,d0
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		d0,(a0)+
	move.w		#2,(a0)+
	bsr		VDI
	move.w		control+12,vhandle
	rts

*---------------------------------------------------------------*
V_CloseVWork:
*---------------------------------------------------------------*
	lea		control,a0
	move.w		#101,(a0)
	move.w		#0,2(a0)
	move.w		#0,4(a0)
	move.w		#0,6(a0)
	move.w		#0,8(a0)
	move.w		vhandle,12(a0)
	bsr		VDI
	rts

*---------------------------------------------------------------*
V_Free:
*---------------------------------------------------------------*
	lea		control,a0
	move.w		#51,(a0)
	move.w		#9,2(a0)
	move.w		#1,4(a0)
	move.w		#0,6(a0)
	move.w		#0,8(a0)
	lea		int_in,a0
	move.w		#3,(a0)+	; flag
	move.w		#0,(a0)+	; smallbox
	move.w		#0,(a0)+
	move.w		#0,(a0)+
	move.w		#0,(a0)+
	move.w		#0,(a0)+	; largebox
	move.w		#0,(a0)+
	move.w		os_screen_w,(a0)+
	move.w		os_screen_h,(a0)+
	bsr.s		AES
	rts

*---------------------------------------------------------------*
AES:
*---------------------------------------------------------------*
	move.l		#aespb,d1
	move.w		#200,d0
	trap		#2	
	rts

*---------------------------------------------------------------*
VDI:
*---------------------------------------------------------------*
	move.l		#vdipb,d1
	moveq		#115,d0
	trap		#2	
	rts

*---------------------------------------------------------------*
clear_bss:
*---------------------------------------------------------------*
	lea		bss_start,a0
	move.l		#bss_end,d0
	sub.l		a0,d0
	addq.l		#4-1,d0
	lsr.l		#2,d0
	bsr		clear_longs
	rts

*---------------------------------------------------------------*
copy_words_down:
*---------------------------------------------------------------*
	movem.l		d0-d2,-(sp)
	moveq		#128-1,d1
	and.l		d0,d1
	bra.s		.strt
.long:	move.w		(a0)+,(a1)+
.strt:	dbra		d1,.long
	lsr.l		#7,d0
	bra		.next
.copy:	move.l		(a0)+,(a1)+
	rept		(256/4)-1
	move.l		(a0)+,(a1)+
	endr
.next:	subq.l		#1,d0
	bpl		.copy
	movem.l		(sp)+,d0-d2
	rts

*---------------------------------------------------------------*
copy_words_up:
*---------------------------------------------------------------*
	movem.l		d0-d2/a0-a1,-(sp)
	add.l		d0,a0
	add.l		d0,a0
	add.l		d0,a1
	add.l		d0,a1
	moveq		#128-1,d1
	and.l		d0,d1
	bra.s		.strt
.long:	move.w		-(a0),-(a1)
.strt:	dbra		d1,.long
	lsr.l		#7,d0
	bra		.next
.copy:	move.l		-(a0),-(a1)
	rept		(256/4)-1
	move.l		-(a0),-(a1)
	endr
.next:	subq.l		#1,d0
	bpl		.copy
	movem.l		(sp)+,d0-d2/a0-a1
	rts

*---------------------------------------------------------------*
copy_longs:
*---------------------------------------------------------------*
	movem.l		d0-d1/a0-a1,-(sp)
	moveq		#64-1,d1
	and.l		d0,d1
	bra.s		.strt
.long:	move.l		(a0)+,(a1)+
.strt:	dbra		d1,.long
	lsr.l		#6,d0
	bra		.next
.copy:	move.l		(a0)+,(a1)+
	rept		64-1
	move.l		(a0)+,(a1)+
	endr
.next:	subq.l		#1,d0
	bpl		.copy
	movem.l		(sp)+,d0-d1/a0-a1
	rts

*---------------------------------------------------------------*
swap_longs:
*---------------------------------------------------------------*
	moveq		#16-1,d1
	and.l		d0,d1
	bra.s		.strt
.long:	move.l		(a0),d2
	move.l		(a1),(a0)+
	move.l		d2,(a1)+
.strt:	dbra		d1,.long
	lsr.l		#4,d0
	move.l		a1,a2
	lea		32.w,a3
	bra.s		.next
.copy:	movem.l		(a0),d1-d7/a6
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	movem.l		d1-d7/a6,(a2)
	add.l		a3,a2
	movem.l		(a0),d1-d7/a6
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	move.l		(a1)+,(a0)+
	movem.l		d1-d7/a6,(a2)
	add.l		a3,a2
.next:	dbra		d0,.copy
	rts

*---------------------------------------------------------------*
clear_longs:
*---------------------------------------------------------------*
	movem.l		d1-d7/a2-a3,-(sp)
	moveq		#0,d2
	move.l		d2,d3
	move.l		d2,d4
	move.l		d2,d5
	move.l		d2,d6
	move.l		d2,d7
	move.l		d2,a2
	move.l		d2,a3
	moveq		#128-1,d1
	and.l		d0,d1
	bra.s		.strt
.long:	move.l		d2,(a0)+
.strt:	dbra		d1,.long
	lsr.l		#7,d0
	move.l		d0,d1
	lsl.l		#8,d1				; *256
	lsl.l		#1,d1				; *2	=  *512
	add.l		d1,a0
	bra.s		.next
.clr:	movem.l		d2-d7/a2-a3,-(a0)		; 4*8*16 = 512
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
	movem.l		d2-d7/a2-a3,-(a0)
.next:	dbra		d0,.clr
	movem.l		(sp)+,d1-d7/a2-a3
	rts

*---------------------------------------------------------------*
flush_keybuffer:
*---------------------------------------------------------------*
.all:	push.w		#11
	trap		#1
	addq.l		#2,sp
	tst.w		d0
	beq.s		.exit
	push.w		#7
	trap		#1
	addq.l		#2,sp
	bra.s		.all
.exit:	rts

*---------------------------------------------------------------*
initialise_system:
*---------------------------------------------------------------*
	clr.l		clock200

	move.l		$114.w,old_114
	move.l		#new_114,$114.w

;	move.l		$4d2.w,old_4d2
;	move.l		#new_4d2,$4d2.w

	rts

*---------------------------------------------------------------*
restore_system:
*---------------------------------------------------------------*
	move.l		old_114,$114.w
;	clr.l		$4d2.w
	rts
	
*---------------------------------------------------------------*
			dc.b	"XBRA"
			dc.b	"ACLK"
*---------------------------------------------------------------*
old_114:		ds.l	1
*---------------------------------------------------------------*
new_114:
*---------------------------------------------------------------*
	addq.l		#1,clock200
	jmp		([old_114.w,pc])

*---------------------------------------------------------------*
			dc.b	"XBRA"
			dc.b	"ACLK"
*---------------------------------------------------------------*
old_4d2:		ds.l	1
*---------------------------------------------------------------*
new_4d2:
*---------------------------------------------------------------*
	addq.l		#3,clock200
	rts

*---------------------------------------------------------------*
			data
*---------------------------------------------------------------*

vdipb:			dc.l	control,int_in,pts_in,int_out,pts_out
aespb:			dc.l	control,global,int_in,int_out,addr_in,addr_out

*---------------------------------------------------------------*
			bss
*---------------------------------------------------------------*

clock200:		ds.l	1

sysfont8x8:		ds.l	1
sysfont8x16:		ds.l	1

vwork_w:		ds.w	1
vwork_h:		ds.w	1

control:
opcode:			ds.w	1
sintin:			ds.w	1
sintout:		ds.w	1
saddrin:		ds.w	1
saddrout:		ds.w	1
			ds.w	6

global:
apversion:		ds.w	1
apcount:		ds.w	1
apid:			ds.w	1
apprivate:		ds.l	1
apptree:		ds.l	1
ap1resv:		ds.l	1	
ap2resv:		ds.l	1
ap3resv:		ds.l	1
ap4resv:		ds.l	1

int_in:			ds.b	256
pts_in:			ds.b	64
int_out:		ds.b	256
pts_out:		ds.b	64
addr_in:		ds.l	4
addr_out		ds.l	4

handle:			ds.w	1
vhandle:		ds.w	1

*---------------------------------------------------------------*
			text
*---------------------------------------------------------------*
